autostew/urls.py
from django.conf.urls import include, url
from django.contrib import admin

urlpatterns = [
    url(r'^accounts/', include('autostew_web_account.urls', namespace='account'), name='account'),
    url(r'^admin/', admin.site.urls, name='admin'),
    url(r'^api/', include('autostew_web_api.urls', namespace='api'), name='api'),
    url(r'^contact/', include('autostew_web_contact.urls', namespace='contact'), name='contact'),
    url(r'^session/', include('autostew_web_session.urls', namespace='session'), name='session'),
    url(r'^user/', include('autostew_web_users.urls', namespace='users'), name='user'),
    url(r'^', include('autostew_web_home.urls', namespace='home'), name='home'),
]

autostew_web_account/urls.py
from django.conf.urls import url

from autostew_web_account.views import login_view, account_view, logout_view, register_view, settings_view, \
    rotation_view, queue_view, add_view, remove_rotated_setup, add_setup_to_rotation, remove_queued_setup, \
    add_setup_to_queue, toggle_kicks_view, set_crash_points_limit, set_custom_motd

urlpatterns = [
    url(r'^add$', add_view, name='add'),
    url(r'^toggle_kicks/(?P<pk>[0-9]+)/?$', toggle_kicks_view, name='toggle_kicks'),
    url(r'^set_crash_points_limit/(?P<pk>[0-9]+)/?$', set_crash_points_limit, name='set_crash_points_limit'),
    url(r'^set_custom_motd/(?P<pk>[0-9]+)/?$', set_custom_motd, name='set_custom_motd'),
    url(r'^settings/(?P<pk>[0-9]+)/?$', settings_view, name='settings'),
    url(r'^rotation/(?P<pk>[0-9]+)/?$', rotation_view, name='rotation'),
    url(r'^rotation/(?P<server_pk>[0-9]+)/remove/(?P<entry_pk>[0-9]+)/?$', remove_rotated_setup, name='remove_rotated_setup'),
    url(r'^rotation/(?P<server_pk>[0-9]+)/add/(?P<setup_pk>[0-9]+)/?$', add_setup_to_rotation, name='add_setup_to_rotation'),
    url(r'^queue/(?P<pk>[0-9]+)/?$', queue_view, name='queue'),
    url(r'^queue/(?P<server_pk>[0-9]+)/remove/(?P<entry_pk>[0-9]+)/?$', remove_queued_setup, name='remove_queued_setup'),
    url(r'^queue/(?P<server_pk>[0-9]+)/add/(?P<setup_pk>[0-9]+)/?$', add_setup_to_queue, name='add_setup_to_queue'),
    url(r'^register/?$', register_view, name='register'),
    url(r'^login/?$', login_view, name='login'),
    url(r'^logout/?$', logout_view, name='logout'),
    url(r'^$', account_view, name='home'),
]

autostew_web_session/urls.py
from django.conf.urls import url
from django.contrib.auth.decorators import login_required
from django.views.generic.base import TemplateView
from django.views.generic.detail import DetailView
from django.views.generic.list import ListView

from autostew_web_session.models.models import Track
from autostew_web_session.models.session import SessionSetup, Session
from autostew_web_session.models.server import Server
from autostew_web_session.views import ParticipantDetailView, SessionList, TrackDetailView, SessionView
from . import views

app_name = 'session'
urlpatterns = [
    url(r'^tracks/?$', ListView.as_view(model=Track), name='tracks'),
    url(r'^tracks/(?P<pk>[0-9]+)/?$', TrackDetailView.as_view(), name='track'),
    url(r'^list/?$', SessionList.as_view(), name='sessions'),
    url(r'^servers/?$', ListView.as_view(model=Server), name='servers'),
    url(r'^servers/(?P<slug>.+)/?$', DetailView.as_view(model=Server, slug_field='name'), name='server'),
    url(r'^(?P<pk>[0-9]+)/?$', SessionView.as_view(), name='session'),
    url(r'^(?P<pk>[0-9]+)/events/?$', views.SessionEvents.as_view(), name='events'),
    url(r'^(?P<session_id>[0-9]+)/participant/(?P<participant_id>[0-9]+)/?$', ParticipantDetailView.as_view(), name='participant'),
    url(r'^snapshot/(?P<pk>[0-9]+)/?$', SessionView.as_view(), name='snapshot'),
    url(r'^setup/create/?$', login_required(views.CreateSessionView.as_view()), name='create_setup'),
    url(r'^setup/list/?$', ListView.as_view(model=SessionSetup, queryset=SessionSetup.objects.filter(is_template=True)), name='setups'),
    url(r'^setup/(?P<pk>[0-9]+)/?$', DetailView.as_view(model=SessionSetup), name='setup'),
]

autostew_web_account/models.py
from django.db import models

# Create your models here.

autostew_web_session/models/models.py
from django.core.urlresolvers import reverse
from django.db import models
from django.db.models.aggregates import Min

from autostew_web_enums import models as enum_models


class Track(models.Model):
    class Meta:
        ordering = ['name']

    ingame_id = models.IntegerField(help_text='pCars internal ID', db_index=True)
    name = models.CharField(max_length=100)
    grid_size = models.SmallIntegerField()
    track_latitude = models.IntegerField(default=0)
    track_longitude = models.IntegerField(default=0)
    track_altitude = models.IntegerField(default=0)

    def __str__(self):
        return self.name

    @classmethod
    def get_or_create_default(cls, ingame_id):
        return cls.objects.get_or_create(ingame_id=ingame_id, defaults={'name': 'Unknown', 'grid_size': 0})[0]

    def get_absolute_url(self):
        return reverse('session:track', args=[str(self.id)])

    def get_fastest_laps_by_vehicle(self, vehicle):
        return Lap.objects.filter(
            session__setup_actual__track=self,
            participant__vehicle=vehicle,
            count_this_lap=True,
            participant__is_player=True,
        ).values(
            'participant',
            'participant__member__steam_user__display_name',
            'participant__vehicle__name'
        ).annotate(fastest_lap_time=Min('lap_time')).order_by('fastest_lap_time')

    def get_fastest_laps_by_vehicle_class(self, vehicle_class):
        return Lap.objects.filter(
            session__setup_actual__track=self,
            participant__vehicle__vehicle_class=vehicle_class,
            count_this_lap=True,
            participant__is_player=True,
        ).values(
            'participant__name',
            'participant__vehicle__name'
        ).annotate(fastest_lap_time=Min('lap_time')).order_by('fastest_lap_time')


class VehicleClass(models.Model):
    class Meta:
        ordering = ['name']

    name = models.CharField(max_length=50)
    ingame_id = models.IntegerField(help_text='pCars internal ID', db_index=True)

    def __str__(self):
        return self.name

    @classmethod
    def get_or_create_default(cls, ingame_id):
        return cls.objects.get_or_create(ingame_id=ingame_id, defaults={'name': 'Unknown'})[0]


class Vehicle(models.Model):
    class Meta:
        ordering = ['name']

    name = models.CharField(max_length=50)
    ingame_id = models.IntegerField(help_text='pCars internal ID', db_index=True)
    vehicle_class = models.ForeignKey(VehicleClass, null=True)

    def __str__(self):
        return self.name

    @classmethod
    def get_or_create_default(cls, ingame_id):
        return cls.objects.get_or_create(ingame_id=ingame_id, defaults={'name': 'Unknown'})[0]


class Livery(models.Model):
    class Meta:
        ordering = ['vehicle__name', 'name']
        verbose_name_plural = "Liveries"

    name = models.CharField(max_length=50)
    id_for_vehicle = models.IntegerField(help_text='pCars internal ID', db_index=True)
    vehicle = models.ForeignKey(Vehicle, null=True)

    @classmethod
    def get_or_create_default(cls, id_for_vehicle, vehicle):
        return cls.objects.get_or_create(
            id_for_vehicle=id_for_vehicle,
            vehicle=vehicle,
            defaults={'name': 'Unknown'}
        )[0]

    def __str__(self):
        return "{} for {}".format(self.name, self.vehicle.name)


class SetupRotationEntry(models.Model):
    class Meta:
        ordering = ('server', 'order', )
        verbose_name_plural = "Rotated setups"
    order = models.IntegerField(help_text='Index of setup in order')
    setup = models.ForeignKey('SessionSetup', on_delete=models.CASCADE, limit_choices_to={'is_template': True})
    server = models.ForeignKey('Server', on_delete=models.CASCADE)


class SetupQueueEntry(models.Model):
    class Meta:
        ordering = ('server', 'order', )
        verbose_name_plural = "Queued setups"
    order = models.IntegerField(help_text='Index of setup in order')
    setup = models.ForeignKey('SessionSetup', on_delete=models.CASCADE, limit_choices_to={'is_template': True})
    server = models.ForeignKey('Server', on_delete=models.CASCADE)


class RaceLapSnapshot(models.Model):
    class Meta:
        ordering = ['session_id', 'lap']

    session = models.ForeignKey('Session')
    snapshot = models.OneToOneField('Session', related_name='+')
    lap = models.IntegerField()

    def get_absolute_url(self):
        return self.snapshot.get_absolute_url()


class Lap(models.Model):
    class Meta:
        ordering = ['session_id', 'lap']

    session = models.ForeignKey('Session', related_name='lap_set')
    session_stage = models.ForeignKey(enum_models.SessionStage)
    participant = models.ForeignKey('Participant')
    lap = models.IntegerField()
    count_this_lap = models.BooleanField()
    lap_time = models.IntegerField()
    position = models.IntegerField()
    sector1_time = models.IntegerField()
    sector2_time = models.IntegerField()
    sector3_time = models.IntegerField()
    distance_travelled = models.IntegerField()

    def is_personal_sector1_race_best_in_stage(self):
        return self._best_in_stage_evaluation('sector1_time')

    def is_personal_sector2_race_best_in_stage(self):
        return self._best_in_stage_evaluation('sector2_time')

    def is_personal_sector3_race_best_in_stage(self):
        return self._best_in_stage_evaluation('sector3_time')

    def is_personal_race_best_in_stage(self):
        return self._best_in_stage_evaluation('lap_time')

    def _best_in_stage_evaluation(self, field_name):
        return getattr(self, field_name) <= self.participant.lap_set.filter(
            **{
                '{}__gt'.format(field_name): 0,
                'session_stage': self.session_stage
            }
        ).aggregate(Min(field_name))['{}__min'.format(field_name)]


class Sector(models.Model):
    class Meta:
        ordering = ['session_id', 'lap', 'sector']

    session = models.ForeignKey('Session')
    session_stage = models.ForeignKey(enum_models.SessionStage)
    participant = models.ForeignKey('Participant')
    lap = models.IntegerField()
    count_this_lap = models.BooleanField()
    sector = models.SmallIntegerField()
    sector_time = models.IntegerField()

autostew_web_account/templates/autostew_web_account/add_server.html
{% extends "autostew_web_home/base.html" %}

{% block content %}

    <h1 class="page-header">Connect a dedicated server</h1>

    <div class="panel panel-primary">
        <div class="panel-heading">
            <h3 class="panel-title">
                Important API settings
            </h3>
        </div>
        <div class="panel-body">
            <p>
                These instructions assume that you did get your DS working without Autostew and want to connect it to
                Autostew. If you need help setting up your DS initially, you can look up the
                <a href="http://forum.projectcarsgame.com/showthread.php?22370-Dedicated-Server-HowTo-(Work-in-Progress)">
                    official forum thread</a>.
            </p>
            <p>
                If you are struggling to get your DS running, try asking for help in the Project CARS forums. You can
                find a lot of nice people there who are ready to help :)
            </p>
            <hr>
            <p>
                To configure your DS you will need to edit the configuration file (<strong>server.cfg</strong>) with a
                text editor or any other tool of your choice. Autostew and your dedicated server will communicate via
                the <strong>HTTP API</strong>. This configuration is <strong>required</strong>. Without it Autostew
                won't work.
            </p>
            <p>
                <strong>Don't just copy and paste those settings!</strong> Find where each setting is in your
                configuration file and set the value properly.
            </p>
            <p>
                Set these values:
            </p>
            <pre>
enableHttpApi : true
httpApiInterface : "0.0.0.0"
httpApiPort : 9000</pre>
            <p>
                You will need to create a user that Autostew can use. To do this, search for the section
                <strong>httpApiUsers</strong> in your configuration file and make it look like this:
            </p>
            <pre>
httpApiUsers : {
    "autostew" : "password",
}</pre>
            <p>
                Replace the word "password" with some actual password. Hint: don't use the same password you use for
                other services, as we will have to know and store this password in our database.
            </p>
            <p>
                You will need to give to the user you just created the permission to manage your dedicated server:
            </p>
            <pre>
httpApiGroups : {
    "private" : [ "autostew" ],
    "admin" : [ "autostew" ],
}
</pre>
            <p>Some other important settings:</p>
            <ol>
                <li>Make sure <strong>eventsLogSize</strong> is at <strong>least 1000</strong>.</li>
                <li>Set <strong>name</strong> to the name you want your DS to have.</li>
                <li>Make sure <strong>allowEmptyJoin</strong> is <strong>true</strong>.</li>
                <li>
                    Set <strong>controlGameSetup</strong> to <strong>false</strong> if you want the game host be able to
                    change the race settings. Set it to <strong>true</strong> if you want Autostew to manage the
                    settings (you will need to configure this later).
                    <strong>If you are unsure, set it to false</strong>.
                </li>
            </ol>
            <p>
                Remember to <strong>restart your DS</strong> to make the new configuration take effect. You will be
                still able to change the settings after the connection with Autostew is set up.
            </p>
            <p>
                When you are done, fill out the form below.
            </p>
        </div>
    </div>

    <script>
        function update_url() {
            var newurl = (
                    "http://" +
                    document.getElementById("api_username").value +
                    ":" +
                    document.getElementById("api_password").value +
                    "@" +
                    document.getElementById("api_address").value +
                    ":" +
                    document.getElementById("api_port").value
            );
            document.getElementById("urltest").textContent = newurl;
            document.getElementById("urltest").href = newurl;
        }
    </script>

    <form method="post" action="{% url 'account:add' %}">
        {% csrf_token %}
        <div class="form-group">
            <label for="name">DS name</label>
            <input type="text" class="form-control" id="name" value="" name="name" placeholder="Your DS name">
        </div>
        <div class="form-group">
            <label for="api_username">HTTP API username</label>
            <input type="text" class="form-control" id="api_username" value="" name="api_username"
                   placeholder="The username you created in the httpApiUsers section"
                   onkeydown="update_url()" onchange="update_url()" oninput="update_url()">
        </div>
        <div class="form-group">
            <label for="api_password">HTTP API password</label>
            <input type="text" class="form-control" id="api_password" value="" name="api_password"
                   placeholder="The password you set in the httpApiUsers section"
                    onkeydown="update_url()" onchange="update_url()" oninput="update_url()">
        </div>
        <div class="form-group">
            <label for="api_address">HTTP API address (IP or DNS)</label>
            <input type="text" class="form-control" id="api_address" value="" name="api_address"
                   placeholder="The address of your DS"
                    onkeydown="update_url()" onchange="update_url()" oninput="update_url()">
        </div>
        <div class="form-group">
            <label for="api_port">HTTP API port</label>
            <input type="number" class="form-control" id="api_port" value="9000" name="api_port"
                   onkeydown="update_url()" onchange="update_url()" oninput="update_url()">
        </div>
        <h3>Check if it works!</h3>
        <p>
            <strong>If everything is correct, you should be able to see your DS admin page by opening this URL:
            <a href="#" id="urltest" target="_blank"></a></strong>
        </p>
        <p>Does it look okay? Then <button type="submit" class="btn btn-danger">submit it!</button></p>
    </form>
{% endblock %}

autostew_web_account/templates/autostew_web_account/home.html
{% extends "autostew_web_home/base.html" %}

{% block content %}

    <h1 class="page-header">Hey {{ user.username }}</h1>

    <div class="panel panel-danger">
        <div class="panel-heading">
            <h3 class="panel-title">
                <strong>Please mind</strong>
            </h3>
        </div>
        <div class="panel-body">
            <p>
                The setup queue and setup rotation will only have an effect if the <strong>controlGameSetup</strong>
                option is set to <strong>true</strong> in your server.cfg!
            </p>
            <p>
                Remember to restart your DS if you change this setting.
            </p>
        </div>
    </div>

    {% for server in servers %}
        <div class="panel panel-default">
            <div class="panel-heading">
                <h3 class="panel-title">
                    {% if not server.back_verified %}<span class="label label-danger">unverified</span>{% endif %}
                    {{ server.name }}
                </h3>
            </div>
            <div class="panel-body">
                {% include 'autostew_web_session/server_badge.html' with server=server %}
                <ul>
                    <li>
                        {% if server.back_kicks %}
                            Kicking <b>enabled</b> <a class="btn btn-danger btn-sm" href="{% url 'account:toggle_kicks' server.id %}">Disable</a>
                        {% else %}
                            Kicking <b>disabled</b> <a class="btn btn-success btn-sm" href="{% url 'account:toggle_kicks' server.id %}">Enable</a>
                        {% endif %}
                    </li>
                    <li>
                        <form class="form-inline" method="post" action="{% url 'account:set_crash_points_limit' server.id %}">
                            {% csrf_token %}
                            <div class="form-group">
                                <label for="back_crash_points_limit">Crash points limit per stage</label>
                                <input type="number" class="form-control input-sm" id="back_crash_points_limit" value="{{ server.back_crash_points_limit }}" name="back_crash_points_limit">
                            </div>
                            <button type="submit" class="btn btn-default btn-sm">Save</button>
                        </form>
                    </li>
                    <li>
                        <form class="form-inline" method="post" action="{% url 'account:set_custom_motd' server.id %}">
                            {% csrf_token %}
                            <div class="form-group">
                                <label for="back_custom_motd">Welcome message (one line!)</label>
                                <input type="text" class="form-control input-sm" id="back_custom_motd" value="{{ server.back_custom_motd }}" name="back_custom_motd">
                            </div>
                            <button type="submit" class="btn btn-default btn-sm">Save</button>
                        </form>
                    </li>
                </ul>
                <a class="btn btn-default" href="{% url 'account:settings' server.id %}">
                    Settings
                </a>
                <a class="btn btn-default" href="{% url 'account:rotation' server.id %}">
                    Setup rotation
                </a>
                <a class="btn btn-default" href="{% url 'account:queue' server.id %}">
                    Setup queue
                </a>
            </div>
        </div>
    {% empty %}
        <p>You own no registered dedicated servers</p>
    {% endfor %}
    <a class="btn btn-default" href="{% url 'account:add' %}">
        Connect your dedicated server to Autostew
    </a>
    <p>
        Do you own a DS that is already connected but it does not show up in this list? Then
        <a href='{% url 'contact:contact' %}'>contact us</a> specifying your DS name and the username you registered
        with.
    </p>
{% endblock %}

autostew_web_account/templates/autostew_web_account/login.html
{% extends "autostew_web_home/base.html" %}

{% block content %}

    <h1 class="page-header">DS admin login</h1>
    <div class="panel panel-primary">
        <div class="panel-heading">
            <h3 class="panel-title">Important</h3>
        </div>
        <div class="panel-body">
            This login is only for dedicated server admins. <strong>If you don't manage a dedicated server, registering
            here won't have any effect for you.</strong>
        </div>
    </div>
    <form method="post" action="{% url 'account:login' %}">
        {% csrf_token %}
        <div class="form-group">
            <label for="username">Username</label>
            <input type="text" class="form-control" id="username" placeholder="Username" name="username">
        </div>
        <div class="form-group">
            <label for="password">Password</label>
            <input type="password" class="form-control" id="password" placeholder="Password" name="password">
        </div>
        <button type="submit" class="btn btn-default">Submit</button>
    </form>
    <p>
        Don't have an account yet? <a href="{% url 'account:register' %}">Register here</a>.
    </p>
{% endblock %}

autostew_web_account/templates/autostew_web_account/register.html
{% extends "autostew_web_home/base.html" %}

{% block content %}

    <h1 class="page-header">DS admin registration</h1>
    <div class="panel panel-primary">
        <div class="panel-heading">
            <h3 class="panel-title">Important</h3>
        </div>
        <div class="panel-body">
            This registration is only for dedicated server admins. <strong>If you don't manage a dedicated server,
            registering here won't have any effect for you.</strong>
        </div>
    </div>
    <form method="post" action="{% url 'account:register' %}">
        {% csrf_token %}
        <div class="form-group">
            <label for="username">Username</label>
            <input type="text" class="form-control" id="username" placeholder="Username" name="username">
        </div>
        <div class="form-group">
            <label for="email">Email</label>
            <input type="email" class="form-control" id="email" placeholder="Email" name="email">
        </div>
        <div class="form-group">
            <label for="password">Password</label>
            <input type="password" class="form-control" id="password" placeholder="Password" name="password">
        </div>
        <div class="form-group">
            <label for="password2">Confirm password</label>
            <input type="password" class="form-control" id="password2" placeholder="Password" name="password2">
        </div>
        <button type="submit" class="btn btn-default">Submit</button>
    </form>
    <p>
        Already have an account? <a href="{% url 'account:login' %}">Login here</a>.
    </p>
{% endblock %}

autostew_web_account/templates/autostew_web_account/server_settings.html
{% extends "autostew_web_home/base.html" %}

{% block content %}

    <h1 class="page-header">{{ server.name }}</h1>

    <form method="post" action="{% comment %}{% url 'account:settings' server.id %}{% endcomment %}#">
        {% csrf_token %}
        <div class="form-group">
            <label for="name">Name</label>
            <input type="text" class="form-control" id="name" value="{{ server.name }}" name="name">
        </div>
        <div class="form-group">
            <label for="api_username">API username</label>
            <input type="text" class="form-control" id="api_username" value="{{ server.api_username }}" name="api_username">
        </div>
        <div class="form-group">
            <label for="api_password">API password</label>
            <input type="api_password" class="form-control" id="api_password" value="{{ server.api_password }}" name="api_password">
        </div>
        <div class="form-group">
            <label for="api_address">API address (IP or DNS)</label>
            <input type="text" class="form-control" id="api_address" value="{{ server.api_address }}" name="api_address">
        </div>
        <div class="form-group">
            <label for="api_port">API port</label>
            <input type="number" class="form-control" id="api_port" value="{{ server.api_port }}" name="api_port">
        </div>

        <div class="checkbox">
            <label for="back_enabled">
                <input type="checkbox" id="back_enabled" {% if server.back_enabled %}checked="checked"{% endif %} name="back_enabled">
                Autostew enabled
            </label>
        </div>
        <div class="checkbox">
            <label for="back_reconnect">
                <input type="checkbox" id="back_reconnect" {% if server.back_reconnect %}checked="checked"{% endif %} name="back_reconnect">
                Auto reconnect
            </label>
        </div>
        <div class="checkbox">
            <label for="back_kicks">
                <input type="checkbox" id="back_kicks" {% if server.back_kicks %}checked="checked"{% endif %} name="back_kicks">
                Kicking enabled
            </label>
        </div>
        <div class="checkbox">
            <label for="back_safety_rating">
                <input type="checkbox" id="back_safety_rating" {% if server.back_safety_rating %}checked="checked"{% endif %} name="back_safety_rating">
                Safety rating enabled
            </label>
        </div>
        <div class="checkbox">
            <label for="back_performance_rating">
                <input type="checkbox" id="back_performance_rating" {% if server.back_performance_rating %}checked="checked"{% endif %} name="back_performance_rating">
                Performance rating enabled
            </label>
        </div>
        <div class="form-group">
            <label for="back_crash_points_limit">Crash points limit per stage</label>
            <input type="number" class="form-control" id="back_crash_points_limit" value="{{ server.back_crash_points_limit }}" name="back_crash_points_limit">
        </div>
        <div class="form-group">
            <label for="back_crash_points_limit_ban_seconds">Ban time in seconds when crash limit exceeded (0 to disable)</label>
            <input type="number" class="form-control" id="back_crash_points_limit_ban_seconds" value="{{ server.back_crash_points_limit_ban_seconds }}" name="back_crash_points_limit_ban_seconds">
        </div>
        <div class="form-group">
            <label for="back_custom_motd">Welcome message (one line!)</label>
            <input type="number" class="form-control" id="back_custom_motd" value="{{ server.back_custom_motd }}" name="back_custom_motd">
        </div>
        <div class="form-group">
            <label>Minimum allowed driver safety class</label>
            <select name="back_minimal_safety_class" id="back_minimal_safety_class">
                <option value="0" {% if not server.back_minimal_safety_class %}selected="selected"{% endif %}>No limit</option>
                {% for class in safety_classes %}
                    <option value="{{ class.id }}" {% if class == server.back_minimal_safety_class %}selected="selected"{% endif %}>
                        {{ class.name }}
                    </option>
                {% endfor %}
            </select>
        </div>

        <button type="submit" class="btn btn-default" disabled="disabled">Save changes</button>
    </form>
{% endblock %}

autostew_web_account/templates/autostew_web_account/setup_queue.html
{% extends "autostew_web_home/base.html" %}

{% block content %}

    <h1 class="page-header">Setup queue for {{ server.name }}</h1>
    <h4>Queued setups</h4>
    <ul>
        {% for entry in server.setupqueueentry_set.all %}
            <li>
                <a class="btn btn-default btn-xs" href="{{ setup.get_absolute_url }}">View</a>
                <a class="btn btn-danger btn-xs" href="{% url 'account:remove_queued_setup' server.id entry.id %}">Remove</a>
                <strong>{{ entry.setup.name }}</strong>
            </li>
        {% empty %}
            <li>Queue empty</li>
        {% endfor %}
    </ul>
    <hr>
    <h4>Available setups</h4>
    <ul>
        {% for setup in setup_templates %}
            <li>
                <a class="btn btn-default btn-xs" href="{{ setup.get_absolute_url }}">View</a>
                <a class="btn btn-success btn-xs" href="{% url 'account:add_setup_to_queue' server.id setup.id %}">Add</a>
                <strong>{{ setup.name }}</strong>
            </li>
        {% empty %}
            <li>No setups available</li>
        {% endfor %}
    </ul>
    <a class="btn btn-default" href="{% url 'session:create_setup' %}">Create new setup</a>
{% endblock %}

autostew_web_account/templates/autostew_web_account/setup_rotation.html
{% extends "autostew_web_home/base.html" %}

{% block content %}

    <h1 class="page-header">Setup rotation for {{ server.name }}</h1>
    <h4>Rotated setups</h4>
    <ul>
        {% for entry in server.setuprotationentry_set.all %}
            <li>
                <a class="btn btn-default btn-xs" href="{{ setup.get_absolute_url }}">View</a>
                <a class="btn btn-danger btn-xs" href="{% url 'account:remove_rotated_setup' server.id entry.id %}">Remove</a>
                <strong>{{ entry.setup.name }}</strong>
            </li>
        {% empty %}
            <li>Rotation empty</li>
        {% endfor %}
    </ul>
    <hr>
    <h4>Available setups</h4>
    <ul>
        {% for setup in setup_templates %}
            <li>
                <a class="btn btn-default btn-xs" href="{{ setup.get_absolute_url }}">View</a>
                <a class="btn btn-success btn-xs" href="{% url 'account:add_setup_to_rotation' server.id setup.id %}">Add</a>
                <strong>{{ setup.name }}</strong>
            </li>
        {% empty %}
            <li>No setups available</li>
        {% endfor %}
    </ul>
    <a class="btn btn-default" href="{% url 'session:create_setup' %}">Create new setup</a>
{% endblock %}